/*
 * Created on 27.02.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package at.bestsolution.drawswf.icon;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;

import javax.swing.Icon;

/**
 * @author tom
 */
public class FillColorIcon implements Icon
{
    public static final int BORDER_SIZE = 2;
    public static final int DEFAULT_SIZE = 20;
    protected int width_;
    protected int height_;
    protected Color fill_color_;
    protected Color fill_color_no_alpha_;
    protected int fill_width_;
    protected int fill_height_;
    protected int border_size_h_;
    protected int border_size_v_;

    public FillColorIcon(Color fill_color, int width, int height, int border_size_h, int border_size_v)
    {
        setFillColor(fill_color);
        width_ = width;
        height_ = height;
        border_size_h_ = border_size_h;
        border_size_v_ = border_size_v;
        fill_width_ = ( width - 2*border_size_h ) / 2;
        fill_height_ = height - 2*border_size_v;
    }

    public FillColorIcon(Color fill_color, int width, int height)
    {
        this(fill_color, width, height, BORDER_SIZE,BORDER_SIZE);
    }

    public FillColorIcon(Color fill_color)
    {
        this(fill_color, DEFAULT_SIZE, DEFAULT_SIZE);
    }

    /* (non-Javadoc)
     * @see javax.swing.Icon#paintIcon(java.awt.Component, java.awt.Graphics, int, int)
     */
    public void paintIcon(Component comp, Graphics g, int x, int y)
    {
        Color c = g.getColor();
        g.setColor(fill_color_);
        g.fillRect( x + border_size_h_, y + border_size_v_, fill_width_, fill_height_ );
        g.setColor(fill_color_no_alpha_);
        g.fillRect( x + border_size_h_ + fill_width_, y + border_size_v_, fill_width_, fill_height_ );
        
        g.setColor(c);
    }

    public void setFillColor(Color color)
    {
        fill_color_ = color;
        fill_color_no_alpha_ = new Color(color.getRed(), color.getGreen(), color.getBlue());
    }

    /* (non-Javadoc)
     * @see javax.swing.Icon#getIconWidth()
     */
    public int getIconWidth()
    {
        return width_;
    }

    /* (non-Javadoc)
     * @see javax.swing.Icon#getIconHeight()
     */
    public int getIconHeight()
    {
        return height_;
    }

}
