/*
 * Created on 21.02.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package at.bestsolution.drawswf.menu;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.util.ResourceBundle;

import javax.swing.JMenu;
import javax.swing.KeyStroke;

import at.bestsolution.drawswf.MainWindow;
import at.bestsolution.drawswf.actions.AbstractDrawAction;
import at.bestsolution.drawswf.actions.ExitAction;
import at.bestsolution.drawswf.actions.FileAction;
import at.bestsolution.drawswf.actions.GraphicTemplateAction;
import at.bestsolution.drawswf.actions.SaveSWFAction;

/**
 * @author tom
 */
public class DrawFileMenu extends JMenu
{
    public  DrawFileMenu( String label, char mnemonic )
    {
        super( label );
        setMnemonic( mnemonic );
        initMenu();
    }
    
    //----------------------------------------------------------------------------
    private void addFileAction(String displayedText, String description, String icon_name, boolean load, int mnemonicKey, KeyStroke accelerator, boolean append)
    {
        FileAction load_action = new FileAction(displayedText, description, icon_name, MainWindow.getDrawingPanel(), load, mnemonicKey, accelerator, append);
        add(load_action);
    }

    //----------------------------------------------------------------------------
    private void addGraphicTemplateAction(String displayedText, String description, String icon_name, int mnemonicKey, KeyStroke accelerator)
    {
        GraphicTemplateAction template_action = new GraphicTemplateAction(displayedText, description, icon_name, MainWindow.getDrawingPanel(), mnemonicKey, accelerator);
        add(template_action);
    }

    //----------------------------------------------------------------------------
    private void addSaveSWFAction(String displayedText, String description, String icon_name, int mnemonicKey, KeyStroke accelerator)
    {
        SaveSWFAction save_swf_action = new SaveSWFAction(displayedText, description, icon_name, MainWindow.getDrawingPanel(), mnemonicKey, accelerator);
        add(save_swf_action);
    }

    private void addSaveRemoteSWFAction(String displayedText, String description, String icon_name, int mnemonicKey, KeyStroke accelerator)
    {
        // RemoteSaveAction remote_save_action = new RemoteSaveAction(displayedText, description, icon_name, MainWindow.getDrawingPanel(), mnemonicKey, accelerator);
        // add(remote_save_action);
    }

//  ----------------------------------------------------------------------------
    private void initMenu()
    {
        ResourceBundle international = MainWindow.getI18n();

        addFileAction(
            international.getString("MainWindowFileItemOpen"),
            international.getString("MainWindowFileItemOpenTooltip"),
            "open.png",
            true,
            international.getString("MainWindowFileItemOpenMn").charAt(0),
            KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK),
            false);
            
        addFileAction(
            international.getString("MainWindowFileItemAppend"),
            international.getString("MainWindowFileItemAppendTooltip"),
            "append.png",
            true,
            international.getString("MainWindowFileItemAppendMn").charAt(0),
            null,
            true);
            
        addFileAction(
            international.getString("MainWindowFileItemSaveAs"),
            international.getString("MainWindowFileItemSaveAsTooltip"),
            "saveas.png",
            false,
            international.getString("MainWindowFileItemSaveAsMn").charAt(0),
            null,
            false);
            
        addGraphicTemplateAction(
            international.getString("MainWindowFileItemLoadTemp"),
            international.getString("MainWindowFileItemLoadTempTooltip"),
            "graphic_template.png",
            international.getString("MainWindowFileItemLoadTempMn").charAt(0),
            null);
            
        addSaveSWFAction(
            international.getString("MainWindowFileItemExport"),
            international.getString("MainWindowFileItemExportTooltip"),
            "export.png",
            international.getString("MainWindowFileItemExportMn").charAt(0),
            KeyStroke.getKeyStroke(KeyEvent.VK_E, ActionEvent.CTRL_MASK));
            
//        addSaveRemoteSWFAction(
//            international.getString("MainWindowRemoteExport"),
//            international.getString("MainWindowRemoteExportTooltip"),
//            "export_remote.png",
//            international.getString("MainWindowRemoteExportMn").charAt(0),
//            KeyStroke.getKeyStroke(KeyEvent.VK_R, ActionEvent.CTRL_MASK));
        addSeparator();

        ExitAction exit_action =
            new ExitAction(
                international.getString("MainWindowFileItemExit"),
                international.getString("MainWindowFileItemExitTooltip"),
                "exit.png",
                MainWindow.getDrawingPanel(),
                international.getString("MainWindowFileItemExitMn").charAt(0),
                KeyStroke.getKeyStroke(KeyEvent.VK_Q, ActionEvent.CTRL_MASK));
        add(exit_action);
    }
    
    /* (non-Javadoc)
     * @see at.bestsolution.drawswf.menu.DrawMenuInterface#addGenericMenuItem(at.bestsolution.drawswf.actions.AbstractDrawAction)
     */
    public void addGenericMenuItem(AbstractDrawAction draw_action, int position )
    {
        insert( draw_action, position );
    }

}
