/*
 * Created on 22.02.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package at.bestsolution.drawswf.toolbar;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.util.ResourceBundle;

import javax.swing.JToolBar;
import javax.swing.KeyStroke;

import at.bestsolution.drawswf.MainWindow;
import at.bestsolution.drawswf.actions.AbstractDrawAction;
import at.bestsolution.drawswf.actions.FileAction;
import at.bestsolution.drawswf.actions.GraphicTemplateAction;
import at.bestsolution.drawswf.actions.SaveSWFAction;

/**
 * @author tom
 */
public class DrawFileToolbar extends JToolBar implements DrawToolbarInterface
{
    public DrawFileToolbar()
    {
        super();
        // setFloatable(false);
        initToolbar();
    }

    //----------------------------------------------------------------------------
    private void addFileAction(String displayedText, String description, String icon_name, boolean load, int mnemonicKey, KeyStroke accelerator, boolean append)
    {
        FileAction load_action = new FileAction(description, icon_name, MainWindow.getDrawingPanel(), load, append);
        add(load_action);
    }

    //----------------------------------------------------------------------------
    private void addGraphicTemplateAction(String displayedText, String description, String icon_name, int mnemonicKey, KeyStroke accelerator)
    {
        GraphicTemplateAction template_action = new GraphicTemplateAction(description, icon_name, MainWindow.getDrawingPanel());
        add(template_action);
    }

    //----------------------------------------------------------------------------
    private void addSaveSWFAction(String displayedText, String description, String icon_name, int mnemonicKey, KeyStroke accelerator)
    {
        SaveSWFAction save_swf_action = new SaveSWFAction(description, icon_name, MainWindow.getDrawingPanel());
        add(save_swf_action);
    }

    private void addSaveRemoteSWFAction(String displayedText, String description, String icon_name, int mnemonicKey, KeyStroke accelerator)
    {
        // RemoteSaveAction remote_save_action = new RemoteSaveAction(description, icon_name, MainWindow.getDrawingPanel());
        // add(remote_save_action);
    }
    
    //----------------------------------------------------------------------------
    private void initToolbar()
    {
        ResourceBundle international = MainWindow.getI18n();
        
        addFileAction( international.getString( "MainWindowFileItemOpen" ), international.getString( "MainWindowFileItemOpenTooltip"), "open.png", true, international.getString( "MainWindowFileItemOpenMn" ).charAt(0), KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK), false );
        addFileAction( international.getString( "MainWindowFileItemAppend" ), international.getString( "MainWindowFileItemAppendTooltip" ), "append.png", true, international.getString( "MainWindowFileItemAppendMn" ).charAt(0), null,true );
        addFileAction( international.getString( "MainWindowFileItemSaveAs" ), international.getString( "MainWindowFileItemSaveAsTooltip" ), "saveas.png", false, international.getString( "MainWindowFileItemSaveAsMn" ).charAt(0), null, false );
        addGraphicTemplateAction( international.getString( "MainWindowFileItemLoadTemp" ), international.getString( "MainWindowFileItemLoadTempTooltip" ), "graphic_template.png", international.getString( "MainWindowFileItemLoadTempMn" ).charAt(0), null );
        addSaveSWFAction( international.getString( "MainWindowFileItemExport" ),international.getString( "MainWindowFileItemExportTooltip" ), "export.png", international.getString( "MainWindowFileItemExportMn" ).charAt(0), KeyStroke.getKeyStroke(KeyEvent.VK_E, ActionEvent.CTRL_MASK) );
        // addSaveRemoteSWFAction( international.getString( "MainWindowRemoteExport" ),international.getString( "MainWindowRemoteExportTooltip" ), "export_remote.png", international.getString( "MainWindowRemoteExportMn" ).charAt(0), KeyStroke.getKeyStroke(KeyEvent.VK_R, ActionEvent.CTRL_MASK) );
        addSeparator();
    }

    /* (non-Javadoc)
     * @see at.bestsolution.drawswf.toolbar.DrawToolbarInterface#addGenericToolbarItem(at.bestsolution.drawswf.actions.AbstractDrawAction, int)
     */
    public void addGenericToolbarItem(AbstractDrawAction draw_action, int position)
    {
        // TODO Auto-generated method stub

    }

}
